<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: Support vector machines</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('svm.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">Support vector machines</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="svm-training"></a>
Training</h1>
<p>MeLOn supports two different types of support vector machines:</p><ul>
<li>support vector regression</li>
<li>one class support vector machine</li>
</ul>
<p>Both model types can be trained using python with the Scikit-Learn package and example training scripts are provided for each. These examples should act as a guide to setting up your own training scripts. <br  />
 <b>Notice:</b> Because not all functionalities that are included in Scikit-learn are supported by MeLOn you should refer to the supported features and their restrictions in the following section when you modify the example training scripts or when you set up your own.</p>
<h2><a class="anchor" id="svm-training-requirements"></a>
Requirements</h2>
<ul>
<li>Python (&gt;=3.6)</li>
<li>scikit-learn (&gt;=0.23.2)</li>
<li>numpy (&gt;=1.19.4)</li>
<li>matplotlib (&gt;=3.3.3)</li>
<li>pandas (&gt;=1.14)</li>
</ul>
<h2><a class="anchor" id="svm-training-model"></a>
Model</h2>
<p>For information on the different model settings and parameters and how to use and set them, please refer to the Scikit-learn documentation of the respective model(<a href="https://sklearn.org/modules/generated/sklearn.svm.SVR.html">Support vector regression</a>, <a href="https://scikit-learn.org/stable/modules/generated/sklearn.svm.OneClassSVM.html">One class support vector machine</a>).</p>
<h3><a class="anchor" id="svm-training-model-restrictions"></a>
Restrictions</h3>
<p>There is only one restriction for choosing the model parameters. Only the following kernels are supported by MeLOn:</p><ul>
<li>linear (<code>linear</code>)</li>
<li>radial basis function (<code>rbf</code>)</li>
</ul>
<h2><a class="anchor" id="svm-training-scaling"></a>
Feature scaling</h2>
<p>MeLOn supports the use of in- and output feature scaling using either a <a href="https://scikit-learn.org/stable/modules/generated/sklearn.preprocessing.MinMaxScaler.html">MinMax-</a> or a <a href="https://scikit-learn.org/stable/modules/generated/sklearn.preprocessing.StandardScaler.html">Standard-scaler</a>.</p>
<h3><a class="anchor" id="svm-training-scaling-restrictions"></a>
Restrictions</h3>
<p>Currently, only a feature range of [-1,1] is supported for the MinMax-scaling, therefore you have to pass <code>feature_range=(-1,1)</code> as an argument to the constructor of the MinMax-Scaler.</p>
<h2><a class="anchor" id="svm-training-file"></a>
Generating the model file.</h2>
<p>To generate the json model file used by the C++ part of MeLOn you have to use the <code>save_model_to_json</code> function from <code>utils.py</code>. <br  />
 Parameters of <code>save_model_to_json</code>:</p><ul>
<li><code>filepath</code>: Path to the location to which the file should be saved</li>
<li><code>filename</code>: Name of the file</li>
<li><code>clf</code>: Model object</li>
<li><code>scalers</code> (optional): Dictionary that contains the feature scaler object. Has to have the following form: <div class="fragment"><div class="line">{</div>
<div class="line">   <span class="stringliteral">&#39;input&#39;</span>: input_scaler_object,</div>
<div class="line">   <span class="stringliteral">&#39;output&#39;</span>: output_scaler_object</div>
<div class="line">}</div>
</div><!-- fragment --> In case you only want to have either in- or output scaling you can leave the other out of the dictionary.</li>
</ul>
<h1><a class="anchor" id="svm-usage"></a>
Usage</h1>
<p>To include the trained network in your MAiNGO problem formulation you can use the MeLOn C++ interface. An example of how to include support vector machines in your optimization can be found in the MAiNGO folder.</p>
<h2><a class="anchor" id="svm-usage-constructors"></a>
Constructors</h2>
<p>SupportVectorRegression and SupportVectorMachineOneClass inherit the constructors of SupportVectorMachine, therefore refer to its documentation for a description of the constructors.</p>
<h3><a class="anchor" id="svm-usage-constructors-svm"></a>
Support vector machine (Abstract parent class: Can't be called!)</h3>
<ol type="1">
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867" title="Default Constructor.">melon::SupportVectorMachine&lt;T&gt;::SupportVectorMachine()</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a26c00f7ec0bfe43f85dc386ae4832916" title="Constructor.">melon::SupportVectorMachine&lt;T&gt;::SupportVectorMachine(std::string modelName)</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a401274575c100133a03e8cbf118153d6" title="Constructor.">melon::SupportVectorMachine&lt;T&gt;::SupportVectorMachine(std::string modelPath, std::string modelName)</a></li>
<li>melon::SupportVectorMachine&lt;T&gt;::SupportVectorMachine(std::shared_ptr&lt;SvmData&gt; modelData)</li>
</ol>
<h3><a class="anchor" id="svm-usage-constructors-svr"></a>
Support vector regression</h3>
<ol type="1">
<li>melon::SupportVectorRegression&lt;T&gt;::SupportVectorRegression()</li>
<li>melon::SupportVectorRegression&lt;T&gt;::SupportVectorRegression(std::string modelName)</li>
<li>melon::SupportVectorRegression&lt;T&gt;::SupportVectorRegression(std::string modelPath, std::string modelName)</li>
<li>melon::SupportVectorRegression&lt;T&gt;::SupportVectorRegression(std::shared_ptr&lt;SvmData&gt; modelData)</li>
</ol>
<h3><a class="anchor" id="svm-usage-constructors-ocsvm"></a>
One class support vector machine</h3>
<ol type="1">
<li>melon::SupportVectorMachineOneClass&lt;T&gt;::SupportVectorMachineOneClass()</li>
<li>melon::SupportVectorMachineOneClass&lt;T&gt;::SupportVectorMachineOneClass(std::string modelName)</li>
<li>melon::SupportVectorMachineOneClass&lt;T&gt;::SupportVectorMachineOneClass(std::string modelPath, std::string modelName, MODEL_FILE_TYPE fileType)</li>
<li>melon::SupportVectorMachineOneClass&lt;T&gt;::SupportVectorMachineOneClass(std::shared_ptr&lt;SvmData&gt; modelData)</li>
</ol>
<h2><a class="anchor" id="svm-usage-prediction"></a>
Prediction</h2>
<h3><a class="anchor" id="svm-usage-prediction-svr"></a>
Support vector regression</h3>
<ol type="1">
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d" title="Calculates prediction based on inputs in reduced space.">melon::SupportVectorRegression&lt;T&gt;::calculate_prediction_reduced_space(const std::vector&lt;T&gt; input)</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8" title="Calculates prediction based on inputs and set constraints for fullspace formulation.">melon::SupportVectorRegression&lt;T&gt;::calculate_prediction_full_space(const std::vector&lt;T&gt; input, const std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</a></li>
</ol>
<h3><a class="anchor" id="svm-usage-prediction-ocsvm"></a>
One class support vector machine</h3>
<ol type="1">
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d" title="Calculates prediction based on inputs in reduced space.">melon::SupportVectorMachineOneClass&lt;T&gt;::calculate_prediction_reduced_space(const std::vector&lt;T&gt; input)</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8" title="Calculates prediction based on inputs and set constraints for fullspace formulation.">melon::SupportVectorMachineOneClass&lt;T&gt;::calculate_prediction_full_space(const std::vector&lt;T&gt; input, const std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</a></li>
</ol>
<h2><a class="anchor" id="svm-usage-internal-variables"></a>
Internal variables</h2>
<h3><a class="anchor" id="svm-usage-internal-variables-svr"></a>
Support vector regression</h3>
<ol type="1">
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273" title="Calculates the number of full space variables.">melon::SupportVectorRegression&lt;T&gt;::get_number_of_full_space_variables()</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf" title="Creates variables for the full space formulation in MAiNGO.">melon::SupportVectorRegression&lt;T&gt;::get_fullspace_variables(size_t&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds)</a></li>
</ol>
<h3><a class="anchor" id="svm-usage-internal-variables-ocsvm"></a>
One class support vector machine</h3>
<ol type="1">
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273" title="Calculates the number of full space variables.">melon::SupportVectorMachineOneClass&lt;T&gt;::get_number_of_full_space_variables()</a></li>
<li><a class="el" href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf" title="Creates variables for the full space formulation in MAiNGO.">melon::SupportVectorMachineOneClass&lt;T&gt;::get_fullspace_variables(size_t&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds)</a> </li>
</ol>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="index.html">MeLOn - Machine Learning models for Optimization</a></li><li class="navelem"><a class="el" href="models.html">Models</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
